#include <string.h>

#include "hmac.h"
#include "sha1.h"

void hmac(const u8 secret[8], u8 challenge[20], u8 id[4], u8 mac[20]) {
  // secret:  shared secret kab, 64 bit
  // counter: challenge, 160 bit
  // id:      public identifier, 32 bit
  u8 buf[64];

  unsigned i;

  for (i = 0; i < 8; ++i)   buf[i] = secret[i] ^ 0x36;
  for (i = 8; i < 64; ++i)  buf[i] = 0x36;

  // Compute inner digest
  sha1_init  ();
  sha1_update(buf, 64);

  for (i = 0; i < 20; ++i)  buf[i] = challenge[i];
  for (i = 20; i < 24; ++i) buf[i] = id[i-20];

  sha1_update(buf, 24);
  sha1_final (mac);

  for (i = 0; i < 8; ++i)   buf[i] = secret[i] ^ 0x5C;
  for (i = 8; i < 64; ++i)  buf[i] = 0x36;

  // Compute outer digest
  sha1_init();
  sha1_update(buf, 64);

  sha1_update(mac, 20);
  sha1_final (mac);

}
