// SHA1 header file
//
// Copyright 2010 Google Inc.
// Author: Markus Gutschke
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef SHA1_H__
#define SHA1_H__

#include <stdint.h>

typedef unsigned char u8;
typedef unsigned int u32;

#define SHA1_BLOCKSIZE     64
#define SHA1_DIGEST_LENGTH 20

typedef struct {
  u32  digest[8];
  u32  count_lo, count_hi;
  u8   data[SHA1_BLOCKSIZE];
  int  local;
  
} SHA1_INFO;

extern SHA1_INFO glb_SHA1_INFO;

void sha1_init();
void sha1_update(const u8 *buffer, int count);
void sha1_final(u8 digest[20]);

#endif
